(*********************************************************************

	Cool`Common`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995 Thomas Cool *)
(* :Package Version: 3.25,  September 1998*)
(* :Mathematica Version: 3.00 *)
(* :License: use of this software file requires a licence usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function.*)
(* :Keywords:    *)
(* :Limitation:   *)
(* :Summary: this is the common package of the Cool Packages   *)


(*default location for CleanSlate`*)

If[!MemberQ[$Path, ToFileName[{$TopDirectory, "AddOns", "ExtraPackages",
"Utilities"}]],
AppendTo[$Path, ToFileName[{$TopDirectory, "AddOns", "ExtraPackages",
"Utilities"}]]];

(*default location for edited versions of packages of others*)

If[!MemberQ[$Path, ToFileName[{$TopDirectory, "AddOns", "Applications",
"Cool", "Others", "Varianed"}]],
AppendTo[$Path, ToFileName[{$TopDirectory, "AddOns", "Applications",
"Cool", "Others", "Varianed"}]]];

If[!MemberQ[$Path, ToFileName[{$TopDirectory, "AddOns", "Applications",
"Cool", "Others"}]],
AppendTo[$Path, ToFileName[{$TopDirectory, "AddOns", "Applications",
"Cool", "Others"}]]];

(* for the proper order, we first do DeclarePackages for key commands*)

DeclarePackage["Cool`Manager`",
{"CurrentOptions", "Dump", "OptionsFilter", "FilterSetOptions", "HoldShell", "Kilroy", "MemoryConstrainedQ", "Redefine", "ReEvaluate", "ResetOptions",  "ResetResults", "Results", "SetResults"}]

DeclarePackage["Cool`List`",
{"Aggregate", "AggregatorQ", "AllQ", "Angle", "Applist", "ArgMaxQ", "ArgMinQ", "Average","BorderTotals", "BorderTotalsQ", "CasesMatch", "Cumulate", "DataFilter", "DeleteElement", "DeleteVectorPosition", "Dif", "DimensionForm", "DimensionMap", "DimensionNest", "Distance", "ExistQ", "FromMold", "FromPolar", "IndexedSort", "InsideTable", "JoinNews", "Lag", "Lead", "MapThreadReplace", "Matrix", "MatrixRowSums", "MatrixTimesDiagonal", "MoveToFirst", "NoNulls", "NonZero", "NonZeroQ", "NRadius", "OnlyNulls", "PartOnList", "Places", "Pick", "Polygamy", "Prima", "RateOfChange", "Repeat", "Smooth", "StDev", "SymbolArray", "SymbolArrayRule", "TakeElements", "TensorForm", "ToMatrix", "ToPolar", "Transposant", "TransposeTensor", "TransposeToFirst", "TwoPointsToLine", "UnitIndex" (*, "UnitChange"*)}]

DeclarePackage["Cool`Tool`",
{"Bank", "Between", "BowElasticity", "ClearFunctionByString", "CombineRules", "Decimals", "DeleteRule", "DQ", "Elasticity", "GeneralizedStringTake", "GrowthRate", "InRange", "InRangeQ", "IntegerSCM", "LinExp", "Logistic", "LogRule", "NestHead", "NIntegrateToFirstZero", "NSolveLinearDynamics", "OnOffFlow", "PaddedString", "PointOfIntersection", "PrintPrepare", "RealRootQ", "RealRoots", "ReplaceByHeadCount", "SawTooth", "SimplifyBy", "SimplifyBySolve", "Slope", "SolveFrom", "SolveFormally", "SolveGeneral", "SolveLHS", "Solve2List", "SortSameQ", "StringListPralse", "StringListQ", "StringToList", "ToPattern", "ToPiecewise", "ToPiecewiseLinear", "UnPattern", "XXPlusSpace"}]

DeclarePackage["Cool`Graphics`",
{"Arcs", "Asymptot", "AsymptotAt", "DashedCircle", "DashingValues", "DisplayFunctionFilter", "EqualProductContour", "EqualSumContour", "EqualValueContour", "LineRasterGP", "ListDensityPlotSquared", "LP2DPlot", "Parallelogram", "ParametricRange", "PhaseDiagram", "PlotLine", "Rainbow", "Triangle", "UtilisationContours"}]

(*For the order, we end with Context*)
DeclarePackage["Cool`Context`",
{"AddedUsage", "AppendToInContext", "ArgumentQ", "BeginContext", "ClearInContext", "Contents", "CtE", "Cure", "DataPackage", "DeCure", "Discard", "KeepVariables", "Key", "Load", "MessagesQ", "NeedsQ", "Pralse", "PutIntoContexts", "Query", "RemoveVariables", "ResetAll", "Scoring", "ShadowHull", "ShowPrivate"}]


BeginPackage["Cool`Common`"]

Autonomous::usage = "Keyword. If f[x_] := ... + Autonomous[\"f\"], then this later autonomous part can be adjusted without redefining the function. You could use any variable of course, but Autonomous[..] would be of help in organising models. Note: The use of Strings here may be advised when the function is subjected to replacements"

$Cool::usage = "The list of packages commonly available, in the (reverse) order in which they are processed. Use in:\n   BeginPackage[newpackage, Join[{...}, $Cool]]"

Add::usage = "Add[x_] := Apply[Plus, Flatten[{x}]]"

eluR::usage = "eluR[x_] := x  /.  Rule[a_, b_] -> Rule[b, a]  reverses rules"

ConstantQ::usage = "ConstantQ[x] tests whether x is a constant (or function of those)"

Constraint::usage = "A general Keyword"

Coefficients::usage = "Keyword to point to a list of Rules for substitution of parameters values.\nE.g. Coefficients -> {a -> .3, b -> .6}.\nE.g. Equations[t_, opts___Rule] := {eqs} /. (Coefficients /. opts) for equations subject to time t. This looks more complicated than Equations[t, a, b], but in more complex situations this can give a larger deal of control of where what is done";

Data::usage = "A general Keyword"

DefinitionToString::usage = "DefinitionToString[x] gives the Definition of x as a Stringed List \"{..., ..., ...}\", which might be submitted again to ToExpression. (Alternative to storing DownValues[x].)"

DefinedQ::usage = "DefinedQ[x] gives True iff x has been used or defined in some fashion or other, so that it has a value or that it is the head of some function"

Delta::usage = "Delta[x -> y, x -> z] gives x -> (y-z)\nDelta[x -> y, x -> z, h] gives x -> h[y,z]"

Options[Division] = {Messages -> Off}

Division::usage = "1) Division[x, y] can be used when Indeterminate stands for missing data. It sets Infinity and ComplexInfinity to Indeterminate. With Messages -> Off, by default, messages on division by 0 are suppressed.\n2) Division can also be applied to the Numerator and Denominator of an expression:\n2a) Division[head, expr, {n___}, {d___}] applies head on expr with separate sequences of arguments d and n, giving\nDivision[head[numerator, n], head[denominator, d]]\n2b) Division[head, expr, {both___}] uses n = d = both."

FunctionDomainQ::usage = "FunctionDomainQ[function, args] renders True when args are in the domain of function, False if not. Must be defined by the user. Default messages are available as:
\n   FunctionDomainQ::dom = \"Value not in the domain\";
\n   FunctionDomainQ::domx = \"Value `1` not in the domain\"";

EquationQ::usage = "EquationQ[x] is False when x reduces to True or False, when Infinity, Indeterminate or ComplexInfinity occur, and when x is a form of 1/y == 0. Otherwise it is True."

Equations::usage = "Keyword. Used as in Equations -> {eq1, ...}"

Expected::usage = "Keyword for Economics, e.g. Expected[\"Inflation\"]"
Expectation::usage = "Keyword for Statistics, e.g. Expectation[x]"

FoldListReverse::usage = "FoldListReverse[f, x, list_List, opts___] is a reverse application of FoldList.\n\E.g. [f, x, {a, b, c}] -> f[x, f[a, f[b,c]]]. The opts are meant for f so one also gets f[u, v, opts]."

FoldReverse::usage = "FoldReverse[f, x, list_List, opts___] the last element of FoldListReverse"

ListOfSymbols::usage = "Keyword. User defined. ListOfSymbols[expr] would consists of {{symbol, explanation}, ....}"

LessComplicatedQ::usage = 
	"LessComplicatedQ[x, y] is True, if x is less complicated than y, otherwise False"


LevelInspect::usage = "LevelInspect[y] prints levelspec and that level of y" 

License::usage = "License[n] gives a rough estimate of the cost of n Mathematica packages written by Thomas Cool. These packages come with free explanatory Mathematica notebooks.\nLicense[n,m] plots the cost function from n to m.\nLicense[] plots the function from 1 to 50.\nRecognised option values are\nLicense -> \"Professional\", \"Student\", \"Other\".\nDo not forget the quotes here."

MapLevel::usage = "MapLevel[f, x, levelspec_:{1}, opts___Rule] = Map[f, Level[x, levelspec, opts]] would be more accurate in mapping to levels than Map."

Nullify::usage = "Nullify[x] sets x to Null if it is any kind of function of Null, and if x is a list, then it applies to elements "

Parameter::usage = "Keyword. Must be defined by the user. Use Parameter[\"y\", \"x\" (, possible sequence number i)] to identify the particular parameter associated with variable x in the function call of y. Use Strings here, so that replacement of x or y does not kill the identification"

PartList::usage = "PartList[expr, y_List] is Part with a list as input rather than a sequence. It evaluates Part[expr, Sequence @@ y]"

PartInspect::usage = "PartInspect[expr, opts] gives a list of the elements in the expr, and the positions of them in the expr. These positions are given as lists, and by applying PartList on them, the elements are recovered. Default option is Expand -> True, so that same elements are recorded by position; otherwise, the positions are collected in a list. Set option Heads -> False if you do not want to include Heads"

FunctionRangeQ::usage = "FunctionRangeQ[function, value] renders True when value is in the range of function, False if not. Must be defined by the user. Default messages are:
\n   FunctionRangeQ::ran = \"Value is not in the range\"
\n   FunctionRangeQ::rany = \"Value `1` is not in the range\""

RealQ::usage = "RealQ[x_] gives True if x is real number"

RealN::usage = "RealN[x_, n_Integer:$MachinePrecision] a generalized version of N[]"

Options[ReplaceRule] = {Union -> True}

ReplaceRule::usage = "1) ReplaceRule[old_List, new_List, opts___ ] where old and new are lists of rules (From -> To). For equal From's, the To's in old are replaced with those in new. This is similar to the (x /. x -> y) direction convention. If option Union -> True (default) then the new From's unknown to old are included in the final result.\n2) ReplaceRule[x_List, opts___]  where x is a list {old, new, newest, hotnew,...}. Replacement goes pairwise from the right. Note that, if Union -> False and the middle rules do not contain items of the right,  then the middle works as a sink, through which the hot news doesn't pass."

ReplaceInRule::usage = "ReplaceInRule[{x__Rule}, {y__Rule}] replaces the RHS's of the x by rules y"

RoundAt::usage = "RoundAt[x_, n_Integer:0] := Round[10^n x] / (10^n)"

RuleQ::usage = "RuleQ[x] tests for a rule, True if (Head[x] === Rule)"

SequenceToRules::usage = "SequenceToRules[{t___}, val] := Map[Rule[#, val]&, {t}]"

SmatchQ::usage = "SmatchQ[a, m] uses either MatchQ or StringMatchQ. If the option Map -> True (default) is set, it evaluates Smatch[#, m] /@ a"

Sorry::usage = "A general statement for unlicenced packages."

Surprise::usage = "Surprise[x_?!StringQ] gives the surprise equation for the variable x, with the surprise value given as Surprise[\"x\"] (and the latter entry is a String). See Expected"

StartValues::usage = "Keyword"


ToName::usage = "ToName[x__] gives the concatenation of {x} for Strings or undefined Symbols"

ToProperName::usage = "ToProperName[x_String] gives a String with the first letter a capital and the rest in lower case. \nToProperName[x__] concatenates (after first applying ToString)"

ToSymbol::usage = "ToSymbol[x__] gives ToExpression of the concatenation of {x}, which also has been Cleared"



ToSequence::usage = "ToSequence[] := ToExpression[\"Sequence[]\"] generates a Sequence[] only when evaluated. For example If[a<b, c, Sequence[]] gives a Null in the second spot, and If[a<b, c, ToSequence[]] gives a Sequence[]"


Ratio::usage = "Keyword"

Value::usage = "Keyword"


Begin["`Private`"]

$Cool = {"Cool`Graphics`", "Cool`Manager`", "Cool`Tool`", "Cool`List`", "Cool`Context`","Cool`Common`"};

Add[x_] := Apply[Plus, Flatten[{x}]]

eluR[x_] := x  /.  Rule -> Composition[Reverse, Rule]

ConstantQ[x_Symbol] := MemberQ[Attributes[x], Constant]
ConstantQ[x_?NumberQ] := True
ConstantQ[f_[x__]] := And @@ (ConstantQ /@ {x})

(*doesnt work in 3.0.0: DefinedQ[x_] := (Definition[x] =!= Null) *)

DefinedQ[x_] := ToString[Definition[x]] =!= "Null"

DefinitionToString[x_] := 

	"{" <> StringReplace[ToString[InputForm[Definition[x]]],  "\n \n" -> ", "] <> "}"

Delta[Rule[x_, y_], Rule[x_, z_]] :=  x -> (y - z)

Delta[Rule[x_, y_], Rule[x_, z_], h_] :=  x -> h[y, z]

Division[x_, y_] := 
		Module[{r, mesq},
		mesq = Messages /. Options[Division];
		If[mesq === Off, Off[Power::infy]; Off[Infinity::indet]];
		r = x / y;
		If[mesq === Off, On[Power::infy]; On[Infinity::indet]];
		r = r /. {Infinity -> Indeterminate, 
			ComplexInfinity -> Indeterminate }
		] (*end module*)

Division[head_, expr_, {b___}] :=	
	Division[head[Numerator[expr], b] ,  head[Denominator[expr], b]]

Division[head_, expr_, {n___}, {d___}]  :=
	Division[head[Numerator[expr], n] ,  head[Denominator[expr], d]]

SetAttributes[Delta, Listable] 

EquationQ[x_] :=
	Module[{y, z, a,b,c,d},
	If[Head[x] =!= Equal, Return[False]];
	If[Position[x, Infinity] =!= {}, Return[False]];
	If[Position[x, Indeterminate] =!= {}, Return[False]];
	If[Position[x, ComplexInfinity] =!= {}, Return[False]];
	(*test on 1/u = 0*)
		y = First[x]; z = Last[x];
		{a,b} = {Numerator[y], Denominator[y]};
		{c,d} = {Numerator[z], Denominator[z]};
		If[Head[a d == b c] =!= Equal, Return[False]];
	True]

FunctionDomainQ::dom = "Value is not in the domain";
FunctionDomainQ::domx = "Value `1` is not in the domain";
FunctionRangeQ::ran = "Value is not in the range";
FunctionRangeQ::rany = "Value `1` is not in the range";

FoldListReverse[f_, x_, lis_List, opts___] := 
		FoldList[f[#2, #1, opts]&, Last[lis], Join[Rest[Reverse[lis]], {x}]]

FoldReverse[f_, x_, lis_List, opts___] := Last[FoldListReverse[f, x, lis, opts]]


LessComplicatedQ[x_, y_] := (* do not specify as lists ! *)

	Module[{a = Depth[x] , b = Depth[y] },

	If[a===b, Greater[Length[y], Length[x]], Greater[b,a]]] (* inverse order *)


LevelInspect[y_] := Module[{r}, r = Range[Depth[y]];
		Transpose[{r, Map[Level[y, {#}]&, r]}]  // MatrixForm // Print ]

License::inp = "Unknown input command";
Options[License] = {License -> "Professional"}

License[xy___] := 
	Module[{x, y, lic,cost, n, opts, b}, 
	opts = Sequence[PlotLabel -> "Cost of # Packages", AxesLabel -> {"#","$"}];
	x = Select[{xy}, (Head[#] =!= Rule)&];
	y = Select[{xy}, RuleQ];
	lic = License /. y /. Options[License];
	b = Switch[lic, "Student", .1, "Other", .2, "Professional", .5, _, 
		Message[License::inp];Return[]];
	cost[n_] := Max[0, 20 (1 + b Log[n]) //N];
Print["Use of this software requires a user license.\nPayments are to Swift account ING.B.NL.2A 3736767\n to the name of\n                 Thomas Cool\n                 Rotterdamsestraat 69\n                 2586 GH Scheveningen\n                 Holland\n\nFrom the available options License -> \"Student\", \"Professional\" or \"Other\", you have chosen:\n                 \""<>lic<> "\"\nThe following are rough estimates based upon the number of packages.\nDo inquire about the actual cost of file packs."];
	Which[x === {}, Plot[cost[n], {n,1,50}, Evaluate[opts]],
	Length[x] === 1, "Estimated cost for " <>ToString @@ x<>
			" packages" -> "$"<>ToString[Floor[cost @@ x]],
	Length[x] === 2, Plot[cost[n], {n, x[[1]], x[[2]]}, Evaluate[opts]],
	_, Message[License::inp]]
	] (*end module*)

$TU = TimeUsed[]; $L = True;
Not::no = "Execution stopped. Buy a license to continue.";

Caching[y_, x_] := If[(!y) && (TimeUsed[] > Cool`Common`Private`$TU + 2000), Message[Not::no], x]


MapLevel[f_, x_, levelspec_:{1}, opts___Rule] := Map[f, Level[x, levelspec, opts]]

Nullify[x_] := If[Position[x, Null] =!= {}, Null, x]
SetAttributes[Nullify, Listable]

(***instead of:
Nullify[x_] := If[ListQ[x], Map[Nullify, x], 
			If[Position[x, Null] =!= {}, Null, x]]
***)


Options[PartInspect] = {Expand -> True, Heads -> True};

PartInspect[y_, opts___Rule] :=  
    Module[{r, s, p, u, t, e, x, h},
    {x, h} = {Expand, Heads} /. {opts} /. Options[PartInspect];
    r = Range[Depth[y]]; 
    s = Level[y, {#1}, Heads -> h] &  /@ r;
    u = Union[Flatten[s]];
    p = Position[y, #, Heads -> h]& /@ u;
    If[x === False, 
    Transpose[{u, p}],
    (*else*)
    t = {}; Do[ e = p[[i]]; t = t ~Join~ Map[{u[[i]], #}&, e] 
    , {i, 1, Length[u]}]; t
    ] (*endif*)
    ] (*endModule*)
    
PartList[t_, y_List] := Part[t, Sequence @@ y]




RealQ[x_] := (Head[x] === Real)

RealN[x_, n_Integer:$MachinePrecision] := 

	If[!RealQ[N[x,n]], 
		Switch[Head[x], 
			List, Map[RealN[#,n]&, x],
			String, RealN[ToExpression[x],n],
			Integer, If[N[x,n] === 0, 0.,N[1. x,n]],
			_,N[x,n]	], 
		N[x,n]]

ReplaceRule[y_List, x_List, opts___ ] :=

	Module[{z, p, temp, o = First /@ y, v = Last /@ y,  r},
	Off[Rule::rhs]; (*also deal with p->p statements*)
	z = x /. ((p_ -> p_) :> (p -> temp));
	r = MapThread[ If[ #1 === #2, #1 -> #3, #1 -> #2]&,  {o, o /. z, v}];
	r = r /. ((p_ -> temp) :> (p -> p));
	On[Rule::rhs];
	If[Union /. {opts} /. Options[ReplaceRule], Union[x, r], r]
	] (*end Module *)

ReplaceRule[x_List, opts___Rule] := 

	FoldReverse[ReplaceRule, First[x], Rest[x], opts]


ReplaceInRule[{o__Rule}, {n__Rule}] :=
	Thread[(First /@ {o}) -> ((Last /@ {o}) /. {n})]

RoundAt[x_, n_Integer:0] := Round[10^n x] / (10^n)

RuleQ[x_] := Head[x] === Rule

SequenceToRules[{t___}, val_] := Map[Rule[#, val]&, {t}]

Options[SmatchQ] = {Map -> True}

SmatchQ[a_List, m_, opts___Rule] := 
	If[True === (Map /. {opts} /. Options[SmatchQ]),
	Map[SmatchQ[#,m]&, a], MatchQ[a,m]]

SmatchQ[a_String, m_, opts___Rule] := StringMatchQ[a, m]
SmatchQ[a_, m_, opts___Rule] := MatchQ[a,m]

Sorry[] := (Print["Use of this package is not covered by a license. Some key routines are therefor not included. Sorry. But you can look at the usage statements what they could do.\n"]; License[])

Sorry[1] := "Use of this package is not covered by a license. Please get your license, for, with more funds available, it will be easier to develop and publish documentation and reference guides.\n ";

Surprise[x_?(!StringQ[#]&)] := 
		(Surprise[#] == x - Expected[#])&[ToString[x]]

ToName[x__] := StringJoin[ToString /@ {x}]

ToProperName[x_String] := 
  ToUpperCase[StringTake[x,1]] <> ToLowerCase[StringDrop[x,1]]


ToProperName[x__] := StringJoin[ToProperName /@ (ToString /@ {x})]



ToSymbol[x__] := Module[{a}, a = StringJoin[ToString /@ {x}];
				Clear @@ {a}; ToExpression[a]]

ToSequence[] := ToExpression["Sequence[]"]



End[]


EndPackage[]


(*Force read for general availability*)
Needs["Cool`Context`"]
Needs["Cool`Declare`"]
Print["See License[] for your license."]
Print["Evaluate ResetAll first if you want to load CleanSlate (and thereby to be able to delete all packages that are loaded after CleanSlate)."]
Print["Evaluate Cool[All] if you want to reserve all command names in the packages listed in CoolPack.m."]
Print["Evaluate Cool[name] if you want to load only the package of that name in CoolPack."]
?CoolPack
(*end/endpackage*)
