(******************************************************************

	Cool`FlatRate`  package


 *******************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1994/95 Thomas Cool *)
(* :Package Version: 1.05, September 1994 / November 1995.*)
(* :Mathematica Version: Windows 2.2.2 *)
(* :Keywords:     Finance, Economics, Date, Calendar *)
(* :Limitation:*)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`FlatRate`", {"Cool`Common`"}]

legendr = "\nLegend for flat rates:" <>
"\n r  rate of interest (coupon cR or market mR) " <>
"\n m  number of periods (maturity)" <>
"\n pp periodical payment (annuity, occ. coupon * par)" <>
"\n w  payment at maturity (par value, principal)" <>
"\n v  present value (capital)"

Amortisation::usage = "Amortisation[r, m, w, v] gives the list of amortisation payments for the whole period. The last element in the list is exclusive of w. See AnnuityTable."<>legendr
	
InterestPayments::usage = "InterestPayments[r, m, w, v] gives the list of interest payments for the whole period. See AnnuityTable."<>legendr
		
DebtTrajectory::usage = "DebtTrajectory[r, m, w, v] gives the level of debt (or capital) during the whole period. The last element in the list is exclusive of w. See AnnuityTable."<>legendr

AnnuityTable::usage = "AnnuityTable[r, m, w, v] gives the table of amortisation and interest payments for the whole period. The last element is exclusive of w."<>legendr
		

CashFlow::usage = "CashFlow[pp, m,  w], with coupon rate cR = pp / w  if  w <> 0" <>legendr

Bullit::usage = "Bullit[cR, m, w] = CashFlow[cR w, m, w], cR coupon rate" <>legendr

FloatingRateNote::usage = "FloatingRateNote[mR, m, w] = CashFlow[ mR w, m, w], mR market rate" <>legendr

PrValue::usage = "PrValue[CashFlow[pp, m, w], r] " <> legendr

Annuity::usage = "Annuity[r, m,  w, v] " <> legendr

Yield::usage = "Yield[CashFlow[pp, m, w], price] solves r from\n   PrValue == price"<> legendr

Remove[legendr]

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
