(*********************************************************************

	Cool`Lags`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995 Thomas Cool *)
(* :Package Version: 1.01,  May 1996.*)
(* :Mathematica Version: 2.2.2 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $1 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]


BeginPackage["Cool`Lags`", Join[{}, $Cool]]

ApplyB::usage ="ApplyB[True] and ApplyB[False] turn on and off the functional use. E.g. (Identity + a B^2)[x[t]]. Default is on. Note that this adjusts the internal definitions of Plus and Times. Note that the canonical order is maintained, but that B still is applied to laggable variates."

RemoveGlobalB::usage = "If B has already been claimed for the Global context, 
as happens with Stine's Package, then removal is a bit tricky. The tricky part comes from the circumstance that we use the Delta of the Cool`Common` package. Evaluating RemoveGlobalB forces a reload of Cool`Common` and Cool`Lags`."

Unprotect[B]
Options[B] = {Timing -> Global`t}

B::usage = "B is the lag operator:\n   B[x[u], u] gives x[u-1]\n   B[x[t]] gives x[t-1] provided that t is the index variable as set in Options[B]. Default {Timing -> Global`t}"

Timing::usage = Key[AddedUsage, Timing, "This option indicates the index variable for which the lag has to be taken. Default: Options[B] = {Timing -> Global`t}"]

Delta::usage = Key[AddedUsage, Delta, "Delta[x[t]] = x[t] - x[t-1]; see the lag operator B"]

LagQ::usage = "LagQ[x_ (, t_)] gives True if a lag occurs in x."

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
