(*********************************************************************

	Cool`PeakLoad`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1997 Thomas Cool *)
(* :Package Version: 1.01,  December 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:   Economics*)
(* :Reference: Akira Takayama, "Mathematical Economics", Dryden Press '74*)
(* :Limitation:  *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`PeakLoad`", Join[{"Cool`Economic`Common`"}, $Cool]]

ImpliedShares::usage = "ImpliedShares[kind, K, {pd, pn}, {v, b, rpk} (,Profit)] gives the implied time shares of d and n at given level K, for kind = All, Part & for under welfare or profit maximisation."

PeakLoadLegend::usage = "Calling PeakLoadLegend gives a review of the variables used here"

LowHighTariffPlot::usage = "LowHighTariffPlot[low, high_List, high2_List, 
high3_List, {t, tmin, tmax}, opts___Rule] displays the regime of two prices, a low tariff (night time) and a high tariff (daytime), for the given range for t. A high tariff is defined with the input format of OnOffFlow[]. The low tariff applies when the high tariff is off. Alternative high tariff regimes can be entered to show the difference with the first; if not required enter {}. Options are passed on to Plot\nNote: Enter {low, offset:0} instead of low, if you want to control the offset. The offset (default 0) is a horizontal line in the Plot. The default warrants that the vertical axis starts at zero"

PeakLoad::usage = "PeakLoad[kind, fd, {pd, pn}, {v, b, rpk} (,Profit)] gives the optimal output and capital stock as function of the time share of pd, for kind = All, Part & for welfare or profit maximisation."

PeakLoadCapital::usage = "PeakLoadCaptital[Point, kind, fd, {pd, pn}, {v, b, rpk, eps}, val:10, opts___Rule] uses FindRoot to determine the implied size of the capital stock as a function of the fraction of time for pd. Kind = All or Part. Note: if fd = {f1, f2} then one gets a range of K"

PeakLoadEquation::usage = "PeakLoadEquation[kind, K, fd, {pd, pn}, {v, b, rpk, eps}] gives the crucial condition at the optimum, for kind = All, Part. If eps = -Infinity then there is welfare maximisation. If eps is entered as {eps}, then the functional value eps[K/b] is taken"

PeakLoadPlot::usage = "PeakLoadPlot[All, f, {pd, pn}, y*, {ymin, ymax}, labels_List:{}, opts___Rule] gives a plot of the peak load problem at full capacity, with f the fraction for pd[], and y* the optimal point.\n
PeakLoadPlot[Part, f, {pd, pn}, {y*, z*}, {ymin, ymax}, labels_List:{}, opts___Rule] gives a plot of the peak load problem at part capacity, with f the fraction for pd[], y* the optimal point for pd[], and z* the optimal point for pn[].\nPlotted is for the range ymin to ymax. Labels can be affixed to the points, and options are passed on to Plot"

UnitCapitalCost::usage = "UnitCapitalCost[All, K, {pd, pn}, {v, b, eps}] gives the range of the unit capital cost given these parameters"




Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
