(*******************************************

	Cool`Probability`  package


 *******************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1997 Thomas Cool *)
(* :Package Version: 1.01,  July 1998.*)
(* :Mathematica Version: 3.0.0 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function.
 *)

Needs["Cool`Common`"]

BeginPackage["Cool`Probability`", Join[{"Statistics`DiscreteDistributions`", 
"Statistics`Common`DistributionsCommon`",
"Cool`Economic`Common`",
"Cool`Statistics`Common`"}, $Cool]]

(*Conditional probability 
	= PROB[A, B | C, D]
	= Pr[A && B, C && D] 
	= Prob[A, B][C, D] 
*)

Bayes::usage = "Bayes[A, B][x___Rule] is a SolveFrom application, using the equations\nPr[A && B] == Pr[A] Pr[A, B]\nPr[A && B] == Pr[B] Pr[B, A]"

PROB::usage = "PROB[...] is a format for probability that humans can read better, but it is less tractible for Mathematica.\nPROB[a, b, c | d, e] reads as the joint probability of a && b && c conditional on d && e. This properly translates as Pr[a && b && c, d && e] or Prob[a, b, c][d, e]. However, the latter reads a bit more complicated, particularly in standard Mathematica output. Thus, while Pr is robust for manipulations, PROB is more readable. See ProbToPr, PrToPROB, PROBToPr, and PrToProb"

Prob::usage = "Prob[a, ..., b] = Pr[a && ... && b] gives the joint probability of a ... b.\nProb[a, ..., b][c, ..., d] = Pr[a && ... && b, c && ... && d] is as the joint probability of a ... b conditional on c ... d. Note that the attribute of Prob has been set to Orderless, so that one can experiment with what this means."

PROBToPr::usage = "List of rules to turn PROB[...] into Pr[...] format"

PrToPROB::usage = "List of rules to turn Pr[...] into PROB[...] format"

SequentialDraws::usage = "SequentialDraws[x__And, y__(And):{}, opts___Rule] gives the likelihood of the (composite) event x given that (composite) event y has occurred before. Options[SequentialDraws] state the start values for the finite number of events n and the number of failures f therein. Thus, without earlier draws, the chance of success is 1 - f/n. Success of an event is denoted by a symbol (say x) and failure is denoted by Not[...] (say Not[x]).\nNB: If x is a composite event, then this is taken as an ordered sequence (default). If you want a statement x to be exemplary of any order, with only the number of failures as the critical criterion, then set the option Order -> False"

FromEvent::usage = "FromEvent[p_Symbol] := {p, Not[p]} can also be applied to lists"

Universe::usage = "Universe[p__Symbol] gives the {p, Not[p]} combinations for the various p symbols (events)"

NumberOfElements::usage = "Keyword"

NumberOfFailures::usage = "Keyword"


ProbToFunction::usage = "ProbToFunction[x, f] takes a probability statement x, and interpretes Prob as probability function f. Proper replacement namely requires that the conditional probabilities are replaced before the marginal ones"

OrRule::usage = "x //. OrRule[] replaces Pr[A || B]. Not Fully Tested"

Options$SequentialDraws::usage = "Default options"


Prospect::usage = "Prospect[profit, loss, chanceOfProfit] is an object that contains the key parameters of a Prospect\nProspect[x_List, p_List] is an object with values x and associated probabilities p\nSee ProspectEV and ProspectU"

ProspectEV::usage = "ProspectEV[x_Prospect] gives the expected value of prospect object x"

ProspectU::usage = "ProspectU[x_Prospect] gives the utility of prospect object x, based on the expected value and the variance (risk)"


ProbToPr::usage = "List of rules to change an expression that uses Prob into an expression that uses Pr"

PrToProb::usage = "List of rules to change an expression that uses Pr into an expression that uses Prob"

ToConditionalRule::usage = "ToConditionalRule[var] creates a rule or set of rules to conditionalise on var. Here, var may also be a list of variables"

ToConditional::usage = "ToConditional[expr, var] turns the joint probability Pr in expr into the marginal probability of var times the conditional probability on var. If var is a list, then this is mapped over var. If var is not stated, then automatically all variables in Pr statements in expr are used"

FromConditionalRule::usage = "FromConditionalRule is a set of rules to deconditionalise"

FromConditional::usage = "FromConditional[expr] tries to determine the joint probabilities starting from the conditional and marginal ones. \nFromConditional[expr, Rule] applies FromConditionalRule
\nFromConditional[expr, Solve] constructs additional rules"

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
