(*********************************************************************

	Cool`ShowPlan`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1994/95 Thomas Cool *)
(* :Package Version: 1.05 Thomas Cool,  August 1995.*)
(* :Mathematica Version: 2.2.2 *)
(* :Keywords:   Graphics, Education, Finance, Planning, Time, Date, Calendar    *)
(* :Limitation: a small tool *)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs.
      See the License[] function if Cool`Common` is present. *)

(* Objective:
We want to have an image of the time lapse between events, and an image of the time span of a plan.
An event is a text and its date,   {Fact[date], date}    (Fact is a String).
Date formats are Mathematica lists or financial dates.
A database contains events and plans.
Plot these events, using these texts as labels, and using vertical line markers.

Since 			Plan[date] = event = { text, date2}

then a new event type is:	{Plan[date], date}

		or:	{{ text, date2}, date}
*)

Needs["Cool`Common`"]

BeginPackage["Cool`ShowPlan`",{"Cool`Time`"}]


EventToGraphicsObject::usage = "EventToGraphicsObject[x_List, h_:5, j_3 ] \n makes a Graphics object of an event {text,date}, h = height of marker, j = position text above that"

EventsOrPlansToGraphicsObjects::usage = "EventsOrPlansToGraphicsObjects[step_:1, x_List, h_:5, j_:3] makes a list of graphics objects of x,\nh = height of markers, j = position texts above that, step = step rate for horizontal lines"

BondToPlan::usage= "BondToPlan[bond_, date_] gives a plan, notably \n {{bond, maturity}, date} where the input dates are in financial and the output dates in standard format"

ShowEvent::usage = "ShowEvent[x_List ,h_:5,  j_:3, opts___Rule] \n  shows event {text,date}, h = height of marker, j = position text above that"

ShowEvents::usage = "ShowEvents[database_List,  h_:5,  j_:3,  opts___Rule] \n  shows list of events,  h = height of markers, j = position texts above that"

PlanToGraphicsObject::usage = "PlanToGraphicsObject[y_List, h_:5, j_:3 ] \n makes a Graphics object of a plan {{text,date},date2}\n  h = height of marker, j = position text above that"

ShowPlan::usage = "ShowPlan[x_List ,h_:5,  j_:3, opts___Rule] \n  show plan {{text,date}, date2},	 h = height of marker, j = position text above that"

ShowPlans::usage = "ShowPlans[step_:1, database_List, h_:5, j_:3, opts___Rule]  \n  shows list of plans,  h = height of markers, j = position texts above that, step = step rate for horizontal lines"

ShowEventsOrPlans::usage = "ShowEventsOrPlans[x_, text_String] shows x, with text as plotlabel,\n using EventsOrPlansToGraphicsObjects"

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
