(*******************************************

	Cool`WorldMap`  package


 *******************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1997 Thomas Cool *)
(* :Package Version: 1.01,  January 1998.*)
(* :Mathematica Version: 3.0.0 *)
(* :Keywords:    *)
(* :Limitation: only standard projection is supported for plots*)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function.*)
(* :Comment: I first made a database where a route would count as a border of some fictious country (sometimes partly open). Then it appeared that WorldPlot uses filled polygons, so it was not possible to combine plots. Therefor I used the WorldGraphics[] routine, etc. etc.*)

Needs["Cool`Common`"]

BeginPackage["Cool`WorldMap`", Join[{"Miscellaneous`WorldPlot`", "Utilities`FilterOptions`", "Miscellaneous`WorldData`", "Miscellaneous`WorldNames`", "Miscellaneous`CityData`", "Miscellaneous`Geodesy`"}, $Cool]]

WesternEurope::usage = "A list of countries commonly indicated by that phrase. Russia and Iceland have not been included"

WesternEurope = {"Bosnia and Herzegovina", "Croatia", "Macedonia", "Slovenia", "Portugal", "Spain", "France", "Italy", "Switzerland","Austria","Germany", "Luxembourg", "Liechtenstein", "Andorra", "Belgium", "Netherlands", "Denmark", "Poland", "Czech Republic", "Slovakia", "Hungary","Albania", "Serbia and Montenegro", "Romania", "Bulgaria", "Greece", "United Kingdom", "Turkey", "Cyprus", "Ireland", "Norway","Sweden","Finland", "Monaco", "Gibraltar", "San Marino", "Belarus", "Estonia", "Latvia", "Lithuania", "Moldova", "Ukraine"};


CityPlotCoordinates::usage = "CityPlotCoordinates[city_String] gives the {x, y} plotting coordinates using minutes as the grid. Note: these coordinates then must be converted again using WorldProjection"

ShowCities::usage = "ShowCities[lis_List] shows cities with coloured dots, with a Stage[] assumed"

ShowRoute::usage = "ShowRoute[cities_List] shows cities with coloured dots and connecting lines, with a Stage[] assumed\nShowRoute[cities_List, route_List] shows cities with coloured dots and the route with connecting lines. Thus, some places where there is a change of direction need not be dotted"

CitiesGO::usage = "CitiesGO[cities_List] gives the graphics object for a list of cities (list of strings), with a Stage[] assumed" 

RouteGP::usage = "RouteGP[cities_List] gives the graphics primitive for a route for a list of cities (list of strings). The cities are given as points and the connections as a line\nRouteGP[cities_List, route_List] only dots the cities and connects the route. Thus, some points where there is a change of direction need not be dotted\nRouteGP[Graphics] contains the graphics directives, default pointsize .02 and colour index R=1, G=0, B=0"

RouteGO::usage = "RouteGO[cities_List] and RouteGO[cities, route} give the graphics object for RouteGP, with a Stage[] assumed"

RouteDistance::usage = "RouteDistance[c_List] gives the distance of a route along a list c of cities. Output is {total, {d1, d2, ...}} so that both the consecutive and the total distance are given"

CountryCityQ::usage = "CountryCityQ[country_String] finds the cities in the database for the given country"

Stage::usage = "Stage[] is a graphics object. WorldGraphics is rather slow, since all the projection points have to be calculated. Using a graphics object can plot quicker. See SetStage. Stage[] is used in ShowCities and ShowRoute.\nNB: A graphics object differs from a WorldGraphics object. A call of SetStage[c] fixes the projection method, while a WorldGraphics primitive has a flexible projection method"


SetStage::usage = "SetStage[countries_List, options] sets Stage[] = WorldPlot[countries, options], and remembers the WorldGraphics options as Stage[Options]"

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
